// MediaViewer.cpp: CMediaViewer NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include <windows.h>
#include <streams.h>
#include <Dvdmedia.h>

#include <stdio.h>

#include "MediaViewer.h"
#include "..\Util\StrUtil.h"
/*#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif*/

//////////////////////////////////////////////////////////////////////
// ǉGUID
//////////////////////////////////////////////////////////////////////

// ColorSpace Converter
DEFINE_GUID(CLSID_ColorSpaceConverter,0x1643E180, 0x90F5, 0x11CE, 0x97, 0xD5, 0x00, 0xAA, 0x00, 0x55,0x59,0x5A);

//////////////////////////////////////////////////////////////////////
// }N`
//////////////////////////////////////////////////////////////////////

#define SAFE_RELEASE(pOblect)				if((pOblect)){(pOblect)->Release(); (pOblect) = NULL;}
#define SAFE_RELEASE_EX(pOblect,refCount)	if((pOblect)){refCount=(pOblect)->Release(); (pOblect) = NULL;}
#ifndef HELPER_RELEASE_EX
#define HELPER_RELEASE_EX(f) { if ( f) { while (f->Release() > 0) {} f = NULL; } }
#endif


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CMediaViewer::CMediaViewer(IEventHandler *pEventHandler)
	: CMediaDecoder(pEventHandler, 1UL, 0UL)
	, m_bInit(false)
	, m_pMediaControl(NULL)

	, m_pFilterGraph(NULL)
	, m_pBonSrcFilter(NULL)
	, m_pAacDecFilter(NULL)
	, m_pMpeg2SeqFilter(NULL)
	, m_pPcmSelFilter(NULL)
	, m_pMp2DemuxFilter(NULL)
	, m_pMpeg2DecFilter(NULL)

	, m_pMp2DemuxInterface(NULL)
	, m_pMp2DemuxRefClock(NULL)

	, m_pMp2DemuxVideoMap(NULL)
	, m_pMp2DemuxAudioMap(NULL)

	, m_pVideoWindow(NULL)
	, m_pBasicVideo(NULL)
	, m_pBasicAudio(NULL)
	
	, m_wVideoEsPID(0xFFFFU)
	, m_wAudioEsPID(0xFFFFU)
	
	, m_wVideoWindowX(0)
	, m_wVideoWindowY(0)
	, m_VideoInfo()
	, m_hOwnerWnd(NULL)
	, m_bFullscreen(false)
	, m_dwRegister(0)
{
	// COMCu
	//::CoInitialize(NULL);

	m_szMpeg2DecorderName[0] = '\0';
	m_szMpeg2DecorderName[119] = '\0';

	m_pBonSrcFilterIF = NULL;
	m_pAacDecFilterIF = NULL;
	m_pMpeg2SeqFilterIF = NULL;
	m_pPcmSelFilterIF = NULL;

	m_bPlay = FALSE;

}

CMediaViewer::~CMediaViewer()
{
	CloseViewer();

	// COMCuJ
	//::CoUninitialize();
}

void CMediaViewer::Reset(void)
{
	BOOL bPlay = m_bPlay;

	if(bPlay == TRUE){
		Stop();
	}

	CMediaDecoder::Reset();

	SetVideoPID(0xFFFFU);
	SetAudioPID(0xFFFFU);

	if(bPlay == TRUE){
		Play();
	}
}

const bool CMediaViewer::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex > GetInputNum())return false;

	CTsPacket *pTsPacket = dynamic_cast<CTsPacket *>(pMediaData);

	// ̓fBAf[^͌݊Ȃ
	if(!pTsPacket)return false;
	
	// tB^Otɓ
	if(m_pBonSrcFilter){
		return m_pBonSrcFilter->InputMedia(pTsPacket);
	}

	return false;
}


IPin *GetPin(IBaseFilter *pFilter,int idx, PIN_DIRECTION PinDir)
{
    BOOL       bFound = FALSE;
    IEnumPins  *pEnum = NULL;
    IPin       *pPin = NULL;
    int iCount;

	if(pFilter == NULL)return NULL;

    pFilter->EnumPins(&pEnum);

    iCount = 0;
    while(pEnum->Next(1, &pPin, 0) == S_OK)
    {
        PIN_DIRECTION PinDirThis;
        pPin->QueryDirection(&PinDirThis);
        if (PinDir == PinDirThis){
        	if(iCount == idx){
        		bFound = TRUE;
        		break;
        	}
        	++iCount;
        }
        pPin->Release();
    }
    pEnum->Release();
    return (bFound ? pPin : 0);  
}

const bool CMediaViewer::OpenViewer(HWND hOwnerHwnd,HWND hMessageDrainHwnd)
{
	if(m_bInit)return false;

	ErrMsg("[inf]OpenViewer");

	HRESULT hReturn=S_OK;
	//ULONG refCount;

	CMediaType MediaTypeVideo;
	CMediaType MediaTypeAudio;	

	IPin *pBonSrcOutputPin = NULL;
	IPin *pMp2DemuxInputPin = NULL;
	IPin *pMp2DemuxVideoPin = NULL;
	IPin *pMp2DemuxAudioPin = NULL;
	IPin *pAacDecInputPin = NULL;
	IPin *pAacDecOutputPin = NULL;
	IPin *pMpeg2SeqInputPin = NULL;
	IPin *pMpeg2SeqOutputPin = NULL;
	IPin *pPcmSelInputPin = NULL;
	IPin *pPcmSelOutputPin = NULL;
	IPin *pMpeg2InPin = NULL;
	IPin *pMpeg2OutPin = NULL;

	try{
		CDirectShowUtil cDSUtil;

		// tB^Ot}l[W\z
		if(::CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, reinterpret_cast<LPVOID *>(&m_pFilterGraph)) != S_OK)throw 1UL;
		AddToRot(m_pFilterGraph, &m_dwRegister);

		// IMediaControlC^tF[X̃NG[
		if(m_pFilterGraph->QueryInterface(IID_IMediaControl, reinterpret_cast<LPVOID *>(&m_pMediaControl)) != S_OK)throw 1UL;

		/* CBonSrcFilter */
		{
			// CX^X쐬
			m_pBonSrcFilter = static_cast<CBonSrcFilter *>(CBonSrcFilter::CreateInstance(NULL, &hReturn));
			if((!m_pBonSrcFilter) || (hReturn != S_OK))throw 1UL;
			//m_pBonSrcFilter->AddRef();
			m_pBonSrcFilter->QueryInterface(IID_IBaseFilter, (void **)(&m_pBonSrcFilterIF));

			
			// tB^Otɒǉ
			//if(m_pFilterGraph->AddFilter(static_cast<IBaseFilter *>(m_pBonSrcFilter), L"BonSrcFilter") != S_OK){
			//if(m_pFilterGraph->AddFilter((IBaseFilter *)m_pBonSrcFilter, L"BonSrcFilter") != S_OK){
			if(m_pFilterGraph->AddFilter(m_pBonSrcFilterIF, L"BonSrcFilter") != S_OK){
				throw 1UL;
			}

			// o̓s擾
			//if(!(pBonSrcOutputPin = m_pBonSrcFilter->GetPin(0))){
			pBonSrcOutputPin = GetPin(m_pBonSrcFilterIF,0,PINDIR_OUTPUT);
			if(pBonSrcOutputPin == NULL){
				throw 1UL;
			}
		}		

		/* MPEG-2 Demultiplexer */
		{
			// MPEG-2 DemultiplexerCX^X쐬
			if(::CoCreateInstance(CLSID_MPEG2Demultiplexer, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, reinterpret_cast<LPVOID *>(&m_pMp2DemuxFilter)) != S_OK)throw 1UL;

			// IMpeg2DemultiplexerC^tF[X̃NG[
			if(m_pMp2DemuxFilter->QueryInterface(IID_IMpeg2Demultiplexer, reinterpret_cast<LPVOID *>(&m_pMp2DemuxInterface)) != S_OK)throw 1UL;

			// MPEG-2 DemultiplexertB^Otɒǉ
			if(m_pFilterGraph->AddFilter(m_pMp2DemuxFilter, L"Mpeg2Demuxer") != S_OK)throw 1UL;

			// MPEG-2 Demultiplexer̓̓s擾
			if(m_pMp2DemuxFilter->FindPin(L"MPEG-2 Stream", &pMp2DemuxInputPin) != S_OK)throw 1UL;
			
			// sڑ(CBonSrcFilter [TS]  [MPEG-2 Stream] MPEG-2 Demultiplexer)
			if(m_pFilterGraph->ConnectDirect(pBonSrcOutputPin, pMp2DemuxInputPin, NULL) != S_OK)throw 1UL;			
			
			// IReferenceClockC^tF[X̃NG[
			if(m_pMp2DemuxFilter->QueryInterface(IID_IReferenceClock, reinterpret_cast<LPVOID *>(&m_pMp2DemuxRefClock)) != S_OK)throw 1UL;

			// t@XNbNI
			if(m_pMp2DemuxFilter->SetSyncSource(m_pMp2DemuxRefClock) != S_OK)throw 1UL;			
			
			// ffBAtH[}bgݒ		
			MediaTypeVideo.InitMediaType();
			MediaTypeVideo.SetType(&MEDIATYPE_Video);
			MediaTypeVideo.SetSubtype(&MEDIASUBTYPE_MPEG2_VIDEO);
			MediaTypeVideo.SetVariableSize();
			MediaTypeVideo.SetTemporalCompression(TRUE);
			MediaTypeVideo.SetSampleSize(0);
			MediaTypeVideo.SetFormatType(&FORMAT_MPEG2Video);
			
			 // tH[}bg\̊m
			MPEG2VIDEOINFO *pVideoInfo = reinterpret_cast<MPEG2VIDEOINFO *>(MediaTypeVideo.AllocFormatBuffer(sizeof(MPEG2VIDEOINFO)));
			if(!pVideoInfo)return false;
			::ZeroMemory(pVideoInfo, sizeof(MPEG2VIDEOINFO));

			// rfIwb_ݒ
			VIDEOINFOHEADER2 &VideoHeader = pVideoInfo->hdr;
			::SetRect(&VideoHeader.rcSource, 0, 0, 720, 480);
			VideoHeader.bmiHeader.biHeight = 480;
			VideoHeader.bmiHeader.biWidth = 720;

			// fo̓s쐬
			if(m_pMp2DemuxInterface->CreateOutputPin(&MediaTypeVideo, L"Video", &pMp2DemuxVideoPin) != S_OK)throw 1UL;

			// fBAtH[}bgݒ	
			MediaTypeAudio.InitMediaType();
			MediaTypeAudio.SetType(&MEDIATYPE_Audio);
			MediaTypeAudio.SetSubtype(&MEDIASUBTYPE_NULL);
			MediaTypeAudio.SetVariableSize();
			MediaTypeAudio.SetTemporalCompression(TRUE);
			MediaTypeAudio.SetSampleSize(0);
			MediaTypeAudio.SetFormatType(&FORMAT_None);

			// o̓s쐬
			if(m_pMp2DemuxInterface->CreateOutputPin(&MediaTypeAudio, L"Audio", &pMp2DemuxAudioPin) != S_OK)throw 1UL;			
			
			// fo̓sIMPEG2PIDMapC^tF[X̃NG[
			if(pMp2DemuxVideoPin->QueryInterface(IID_IMPEG2PIDMap, reinterpret_cast<LPVOID *>(&m_pMp2DemuxVideoMap)) != S_OK)throw 1UL;

			// o̓sIMPEG2PIDMapC^tF[X̃NG[
			if(pMp2DemuxAudioPin->QueryInterface(IID_IMPEG2PIDMap, reinterpret_cast<LPVOID *>(&m_pMp2DemuxAudioMap)) != S_OK)throw 1UL;			
		}

		/* CMpeg2SequenceFilter */
		{
			// CX^X쐬
			m_pMpeg2SeqFilter = static_cast<CMpeg2SequenceFilter *>(CMpeg2SequenceFilter::CreateInstance(NULL, &hReturn));
			if((!m_pMpeg2SeqFilter) || (hReturn != S_OK))throw 1UL;
			//m_pMpeg2SeqFilter->AddRef();
			m_pMpeg2SeqFilter->QueryInterface(IID_IBaseFilter, (void **)(&m_pMpeg2SeqFilterIF));
			m_pMpeg2SeqFilter->SetRecvCallback(OnMpeg2VideoInfo,this);
			
			// CMpeg2SequenceFiltertB^Otɒǉ
			//if(m_pFilterGraph->AddFilter(static_cast<IBaseFilter *>(m_pMpeg2SeqFilter), L"Mpeg2SequenceFilter") != S_OK)throw 1UL;
			if(m_pFilterGraph->AddFilter(m_pMpeg2SeqFilterIF, L"Mpeg2SequenceFilter") != S_OK)throw 1UL;

			// CMpeg2SequenceFilter̓̓s擾
			//if(!(pMpeg2SeqInputPin = m_pMpeg2SeqFilter->GetPin(0)))throw 1UL;
			pMpeg2SeqInputPin = GetPin(m_pMpeg2SeqFilterIF,0,PINDIR_INPUT);
			if(pMpeg2SeqInputPin == NULL)throw 1UL;

			// CMpeg2SequenceFilteȑo̓s擾
			//if(!(pMpeg2SeqOutputPin = m_pMpeg2SeqFilter->GetPin(1)))throw 1UL;
			pMpeg2SeqOutputPin = GetPin(m_pMpeg2SeqFilterIF,0,PINDIR_OUTPUT);
			if(pMpeg2SeqOutputPin == NULL)throw 1UL;

			// sڑ(MPEG-2 Demultiplexer [Video]  [] CMpeg2SequenceFilter)
			if(m_pFilterGraph->ConnectDirect(pMp2DemuxVideoPin, pMpeg2SeqInputPin, NULL) != S_OK)throw 1UL;
		}

		/* CAacDecFilter */
		{
			// CAacDecFilterCX^X쐬
			m_pAacDecFilter = static_cast<CAacDecFilter *>(CAacDecFilter::CreateInstance(NULL, &hReturn));
			if((!m_pAacDecFilter) || (hReturn != S_OK))throw 1UL;
			//m_pAacDecFilter->AddRef();		
			m_pAacDecFilter->QueryInterface(IID_IBaseFilter, (void **)(&m_pAacDecFilterIF));
			
			// CAacDecFiltertB^Otɒǉ
			//if(m_pFilterGraph->AddFilter(static_cast<IBaseFilter *>(m_pAacDecFilter), L"AacDecFilter") != S_OK)throw 1UL;
			if(m_pFilterGraph->AddFilter(m_pAacDecFilterIF, L"AacDecFilter") != S_OK)throw 1UL;

			// CAacDecFilter̓̓s擾
			//if(!(pAacDecInputPin = m_pAacDecFilter->GetPin(0)))throw 1UL;
			pAacDecInputPin = GetPin(m_pAacDecFilterIF,0,PINDIR_INPUT);
			if(pAacDecInputPin == NULL)throw 1UL;

			// CAacDecFilteȑo̓s擾
			//if(!(pAacDecOutputPin = m_pAacDecFilter->GetPin(1)))throw 1UL;
			pAacDecOutputPin = GetPin(m_pAacDecFilterIF,0,PINDIR_OUTPUT);
			if(pAacDecOutputPin == NULL)throw 1UL;

			// sڑ(MPEG-2 Demultiplexer [Audio]  [] CAacDecFilter)
			if(m_pFilterGraph->ConnectDirect(pMp2DemuxAudioPin, pAacDecInputPin, NULL) != S_OK)throw 1UL;
		}

		/* CPcmSelectFilter */
		{
			// CX^X쐬
			m_pPcmSelFilter = static_cast<CPcmSelectFilter *>(CPcmSelectFilter::CreateInstance(NULL, &hReturn));
			if((!m_pPcmSelFilter) || (hReturn != S_OK))throw 1UL;
			//m_pPcmSelFilter->AddRef();
			m_pPcmSelFilter->QueryInterface(IID_IBaseFilter, (void **)(&m_pPcmSelFilterIF));

			// CPcmSelectFiltertB^Otɒǉ
			//if(m_pFilterGraph->AddFilter(static_cast<IBaseFilter *>(m_pPcmSelFilter), L"PcmSelFilter") != S_OK)throw 1UL;
			if(m_pFilterGraph->AddFilter(m_pPcmSelFilterIF, L"PcmSelFilter") != S_OK)throw 1UL;

			// CPcmSelectFilter̓̓s擾
			//if(!(pPcmSelInputPin = m_pPcmSelFilter->GetPin(0)))throw 1UL;
			pPcmSelInputPin = GetPin(m_pPcmSelFilterIF,0,PINDIR_INPUT);
			if(pPcmSelInputPin == NULL)throw 1UL;

			// CPcmSelectFilteȑo̓s擾
			//if(!(pPcmSelOutputPin = m_pPcmSelFilter->GetPin(1)))throw 1UL;
			pPcmSelOutputPin = GetPin(m_pPcmSelFilterIF,0,PINDIR_OUTPUT);
			if(pPcmSelOutputPin == NULL)throw 1UL;

			// sڑ(CAacDecFilter  [] CPcmSelectFilter)
			if(m_pFilterGraph->ConnectDirect(pAacDecOutputPin, pPcmSelInputPin, NULL) != S_OK)throw 1UL;
		}		

		/* Mpeg2fR[_[ */
		{

			// 
			if(!cDSUtil.FindFilter(&MEDIATYPE_Video,&MEDIASUBTYPE_MPEG2_VIDEO)) throw 1UL;
			//CString strMpeg2Vid;
			char szMpeg2Vid[120];
			CLSID idMpeg2Vid;
			int iIndex;			

			bool bConnectSuccess=false;


			for(iIndex=0;!bConnectSuccess&&iIndex<cDSUtil.GetFilterCount();iIndex++){
				szMpeg2Vid[119] = '\0';
				
				if(cDSUtil.GetFilterInfo(iIndex,&idMpeg2Vid,&szMpeg2Vid[0],119)){
					
					if(::CoCreateInstance(idMpeg2Vid, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, reinterpret_cast<LPVOID *>(&m_pMpeg2DecFilter)) == S_OK){				
						
						// CPcmSelectFiltertB^Otɒǉ
						if(m_pFilterGraph->AddFilter(static_cast<IBaseFilter *>(m_pMpeg2DecFilter), L"MPEG2 Decoder") == S_OK){
							// Mpeg2fR[_[s
							MediaTypeVideo.SetSubtype(&MEDIASUBTYPE_NULL);
							
							pMpeg2InPin = cDSUtil.GetFilterPin(m_pMpeg2DecFilter,PINDIR_INPUT,NULL);
							pMpeg2OutPin = cDSUtil.GetFilterPin(m_pMpeg2DecFilter,PINDIR_OUTPUT,NULL);

							// sڑ(CMpeg2SequenceFilter  [] Mpeg2Decorder)
							if(m_pFilterGraph->ConnectDirect(pMpeg2SeqOutputPin, pMpeg2InPin, NULL) == S_OK){
								// sڑ
								bConnectSuccess = true;
							} else {
								// sڑŝ߁AtB^Ot菜
								m_pFilterGraph->RemoveFilter(m_pMpeg2DecFilter);
								//tB^
								SAFE_RELEASE(m_pMpeg2DecFilter);
								SAFE_RELEASE(pMpeg2InPin);
								SAFE_RELEASE(pMpeg2OutPin);
							}
	
							if(bConnectSuccess == true)break;

						} else {
							// tB^Otɒǉs
							SAFE_RELEASE(m_pMpeg2DecFilter);
						}
					} else {
						// fR[_[̃CX^X쐬s
					}
				} else {
					// tB^擾s
			}
		}

		// ǂꂩ̃tB^Őڑł
		if(bConnectSuccess){
				//m_szMpeg2DecorderName = strMpeg2Vid;
				strcpy_s(m_szMpeg2DecorderName,119,szMpeg2Vid);
			} else {
				m_szMpeg2DecorderName[0] = '\0';
				throw 1UL;
			}
		}		


		// f_[\z
		if(m_pFilterGraph->Render(pMpeg2OutPin) != S_OK)throw 1UL;

		// _[\z
		if(m_pFilterGraph->Render(pPcmSelOutputPin) != S_OK)throw 1UL;		

		// IVideoWindowC^tF[X̃NG[
		if(m_pFilterGraph->QueryInterface(IID_IVideoWindow, reinterpret_cast<LPVOID *>(&m_pVideoWindow)) != S_OK)throw 1UL;		

		// IBasicVideo2C^[tF[X̃NG[
		if(m_pFilterGraph->QueryInterface(IID_IBasicVideo2, reinterpret_cast<LPVOID *>(&m_pBasicVideo)) != S_OK)throw 1UL;

		// IBasicAudioC^[tF[X̃NG[
		if(m_pFilterGraph->QueryInterface(IID_IBasicAudio, reinterpret_cast<LPVOID *>(&m_pBasicAudio)) != S_OK)throw 1UL;
		
		// I[iEBhEݒ
		if(m_pVideoWindow&&hOwnerHwnd){
			m_hOwnerWnd = hOwnerHwnd;
			m_pVideoWindow->put_Owner((OAHWND)hOwnerHwnd);
			m_pVideoWindow->put_MessageDrain((OAHWND)hMessageDrainHwnd);
			m_pVideoWindow->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS);
			m_pVideoWindow->put_BackgroundPalette(OATRUE);
			m_pVideoWindow->put_BorderColor(RGB(0,0,0));
			m_pVideoWindow->put_Caption(L"");
			m_pVideoWindow->put_AutoShow(OAFALSE);
			
			RECT Rect;
			::GetClientRect(hOwnerHwnd, &Rect);
			m_pVideoWindow->SetWindowPosition(0, 0, Rect.right - Rect.left, Rect.bottom - Rect.top);
			m_pVideoWindow->SetWindowForeground(OATRUE);
			m_pVideoWindow->put_Visible(OATRUE);
			SetViewSize(Rect.right - Rect.left, Rect.bottom - Rect.top);
		}				

		m_bInit=true;
	}
	

	catch(DWORD dwErrorCode){
		CloseViewer();
		return false;
	}

	// OtŎQƂāAQƃJEgオĂ̂ŉĂȂ	
	SAFE_RELEASE(pBonSrcOutputPin);
	SAFE_RELEASE(pMp2DemuxVideoPin);
	SAFE_RELEASE(pMp2DemuxAudioPin);
	SAFE_RELEASE(pMp2DemuxInputPin);
	SAFE_RELEASE(pAacDecInputPin);
	SAFE_RELEASE(pAacDecOutputPin);
	SAFE_RELEASE(pMpeg2SeqInputPin);
	SAFE_RELEASE(pMpeg2SeqOutputPin);
	SAFE_RELEASE(pPcmSelInputPin);
	SAFE_RELEASE(pPcmSelOutputPin);
	SAFE_RELEASE(pMpeg2InPin);
	SAFE_RELEASE(pMpeg2OutPin);

	printf("tB^Ot\z\n");
	
	return true;
}

//////////////////////////////////////////////////////////////////////////////
//tB^Ot̃tB^폜
BOOL ClearFilterGraph(IGraphBuilder *pGraph){
	HRESULT hr;

	if(pGraph == NULL)return FALSE;

	// Ot̃tB^񋓂B
	IEnumFilters *pEnum = NULL;
	hr = pGraph->EnumFilters(&pEnum);
	if (SUCCEEDED(hr))
	{
	    IBaseFilter *pFilter = NULL;
	    while (S_OK == pEnum->Next(1, &pFilter, NULL))
	     {
	         // tB^폜B
	         hr = pGraph->RemoveFilter(pFilter);
			 if(FAILED(hr)){
				 ErrMsg("[Err]ClearFilterGraph : Fail hr = %08x",hr);
				 break;
			 }
	         // 񋓎qZbgB
	         pEnum->Reset();
	         pFilter->Release();
	    }
	    pEnum->Release();
	}
	return TRUE;
}

void CMediaViewer::CloseViewer(void)
{	

	// COMCX^XJ
	ULONG RefCount=0;
	Stop();

	if(m_pVideoWindow){
		m_pVideoWindow->put_Visible(OAFALSE);
		m_pVideoWindow->put_MessageDrain((OAHWND)NULL);
		m_pVideoWindow->put_Owner(NULL);
	}
	

	SAFE_RELEASE(m_pMediaControl);
	SAFE_RELEASE(m_pVideoWindow);

	ClearFilterGraph(m_pFilterGraph);

	SAFE_RELEASE(m_pBasicVideo);
	SAFE_RELEASE(m_pBasicAudio);

	SAFE_RELEASE(m_pMp2DemuxVideoMap);
	SAFE_RELEASE(m_pMp2DemuxAudioMap);

	SAFE_RELEASE(m_pMp2DemuxRefClock);
	SAFE_RELEASE(m_pMp2DemuxInterface);
	SAFE_RELEASE(m_pMp2DemuxFilter);
	SAFE_RELEASE(m_pMpeg2DecFilter);

	SAFE_RELEASE_EX(m_pAacDecFilter,RefCount);
	//HELPER_RELEASE_EX(m_pAacDecFilter);
	ErrMsg("[inf]CMediaViewer::CloseViewer m_pAacDecFilter = RefCount=%d",RefCount);

	//SAFE_RELEASE(m_pBonSrcFilter);
	SAFE_RELEASE_EX(m_pBonSrcFilter,RefCount);
	//HELPER_RELEASE_EX(m_pBonSrcFilter);
	ErrMsg("[inf]CMediaViewer::CloseViewer m_pBonSrcFilter = RefCount=%d",RefCount);

	//SAFE_RELEASE(m_pMpeg2SeqFilter);
	SAFE_RELEASE_EX(m_pMpeg2SeqFilter,RefCount);
	//HELPER_RELEASE_EX(m_pMpeg2SeqFilter);
	ErrMsg("[inf]CMediaViewer::CloseViewer m_pMpeg2SeqFilter = RefCount=%d",RefCount);

	SAFE_RELEASE_EX(m_pPcmSelFilter,RefCount);
	//HELPER_RELEASE_EX(m_pPcmSelFilter);
	ErrMsg("[inf]CMediaViewer::CloseViewer m_pPcmSelFilter = RefCount=%d",RefCount);

	if(m_dwRegister!=0){
		RemoveFromRot(m_dwRegister);
	}
	m_dwRegister = 0;

	SAFE_RELEASE(m_pFilterGraph);
	// RefCount = 0 ɂȂĂȂ΂ǂŉRꂪ
}

const bool CMediaViewer::Play(void)
{
	bool bRet;

	if(!m_pMediaControl)return false;
	if(m_bPlay == TRUE)return true;

	// tB^OtĐ
	m_pMediaControl->Run();
		
	bRet = (m_pMediaControl->Run() == S_OK) ? true : false;

	m_bPlay = TRUE;

	return bRet;
}

const bool CMediaViewer::Stop(void)
{
	bool bRet;

	if(!m_pMediaControl)return false;
	if(m_bPlay == FALSE)return true;

	// tB^Ot~
	bRet = (m_pMediaControl->Stop() == S_OK)? true : false;

	m_bPlay = FALSE;

	return bRet;
}

const bool CMediaViewer::Pause(void){
	bool bRet;

	if(!m_pMediaControl)return false;
	if(m_bPlay == FALSE)return true;

	// tB^Ot~
	bRet = (m_pMediaControl->Pause() == S_OK)? true : false;

	return bRet;
}

const bool CMediaViewer::SetVideoPID(const WORD wPID)
{
	// fo̓sPID}bsO
	if(!m_pMp2DemuxVideoMap)return false;

	if(wPID == m_wVideoEsPID)return true;

	DWORD dwTempPID;

	// ݂PIDA}bv
	if(m_wVideoEsPID != 0xFFFFU){
		dwTempPID = (DWORD)m_wVideoEsPID;
		if(m_pMp2DemuxVideoMap->UnmapPID(1UL, &dwTempPID) != S_OK)return false;
		}

	// VKPID}bv
	if(wPID != 0xFFFFU){
		dwTempPID = wPID;
		if(m_pMp2DemuxVideoMap->MapPID(1UL, &dwTempPID, MEDIA_ELEMENTARY_STREAM) != S_OK)return false;
		}

	m_wVideoEsPID = wPID;
	
	return true;
}

const bool CMediaViewer::SetAudioPID(const WORD wPID)
{
	// o̓sPID}bsO
	if(!m_pMp2DemuxAudioMap)return false;

	if(wPID == m_wAudioEsPID)return true;

	DWORD dwTempPID;

	// ݂PIDA}bv
	if(m_wAudioEsPID != 0xFFFFU){
		dwTempPID = (DWORD)m_wAudioEsPID;
		if(m_pMp2DemuxAudioMap->UnmapPID(1UL, &dwTempPID) != S_OK)return false;
		}

	// VKPID}bv
	if(wPID != 0xFFFFU){
		dwTempPID = wPID;
		if(m_pMp2DemuxAudioMap->MapPID(1UL, &dwTempPID, MEDIA_ELEMENTARY_STREAM) != S_OK)return false;
		}

	m_wAudioEsPID = wPID;
	
	return true;
}

void CMediaViewer::OnMpeg2VideoInfo(const Mpeg2VideoInfo *pVideoInfo,const LPVOID pParam)
{
	// rfI̍XV
	CMediaViewer *pThis=static_cast<CMediaViewer*>(pParam);
	if(memcmp(&pThis->m_VideoInfo,pVideoInfo,sizeof(Mpeg2VideoInfo))){
		// rfI̍XV
		pThis->m_VideoInfo = *pVideoInfo;
		pThis->ResizeVideoWindow();
		}
}

const bool CMediaViewer::ResizeVideoWindow()
{
	// EBhETCYύX
	if(m_pVideoWindow && m_pBasicVideo){
		WORD wX,wY;
		if(m_bFullscreen){			
			wX = (WORD)GetSystemMetrics(SM_CXSCREEN);
			wY = (WORD)GetSystemMetrics(SM_CYSCREEN);
			} else {
			wX = m_wVideoWindowX;
			wY = m_wVideoWindowY;
			}
		double vx , vy;
		if(m_VideoInfo.byAspectRatioX>0 && m_VideoInfo.byAspectRatioY>0){
			double aspect_rate = (double)m_VideoInfo.byAspectRatioX / (double)m_VideoInfo.byAspectRatioY;
			double window_rate = (double)wX / (double)wY;
			if(aspect_rate>window_rate){
				vx = wX;
				vy = vx * m_VideoInfo.byAspectRatioY  / m_VideoInfo.byAspectRatioX;
				} else {
				vy = wY;
				vx = vy * m_VideoInfo.byAspectRatioX / m_VideoInfo.byAspectRatioY;
				}
			} else {
			vx = wX;
			vy = wY;
			}
		HRESULT hr;
		hr = m_pBasicVideo->SetSourcePosition(m_VideoInfo.wPosX,m_VideoInfo.wPosY,m_VideoInfo.wWidth,m_VideoInfo.wHeight);
		hr = m_pBasicVideo->SetDestinationPosition((int)(wX-vx)/2,(int)(wY-vy)/2,(int)vx,(int)vy);
		hr = m_pVideoWindow->HideCursor(m_bFullscreen?OATRUE:OAFALSE);
		
		hr = m_pVideoWindow->put_Left(0);
		if(SUCCEEDED(hr)){
			hr = m_pVideoWindow->put_Width(wX);
			if(SUCCEEDED(hr)){
				hr = m_pVideoWindow->put_Top(0);
				if(SUCCEEDED(hr)){
					hr = m_pVideoWindow->put_Height(wY);
					if(SUCCEEDED(hr)){
						return true;
						}
					}
				}
			}
		}
	return false;
}

const bool CMediaViewer::SetViewSize(const int x,const int y)
{
	// EBhETCYݒ肷
	if(m_pVideoWindow && x>0 && y>0){
		m_wVideoWindowX = x;
		m_wVideoWindowY = y;
		return ResizeVideoWindow();
		}
	return false;
}

const bool CMediaViewer::SwitchFullscreen()
{
	// EBhE[hƃtXN[[h؂ւ	
	if(m_pVideoWindow){
		m_bFullscreen = !m_bFullscreen;
		m_pVideoWindow->put_Visible(OAFALSE);
		if(m_bFullscreen){
			m_pVideoWindow->put_Owner(NULL);			
			} else {
			m_pVideoWindow->put_Owner((OAHWND)m_hOwnerWnd);
			}
		m_pVideoWindow->put_Visible(OATRUE);
		ResizeVideoWindow();
		}		
	return true;
	/*
	long lMode;
	if(m_pVideoWindow){
		HRESULT hr = m_pVideoWindow->get_FullScreenMode(&lMode);
		if(SUCCEEDED(hr)){
			RECT Rect;
			if(lMode==OATRUE){
				// to Window
				hr = m_pVideoWindow->put_FullScreenMode(OAFALSE);
				if(SUCCEEDED(hr)){
					return true;
					}
			} else {
				// to Fullscreen
				hr = m_pVideoWindow->put_FullScreenMode(OATRUE);
				if(SUCCEEDED(hr)){
					return true;
					}
				}		
			}
		}
	return false;
	*/
}

const bool CMediaViewer::SetVolume(const long lVolume)
{
	// I[fBI{[dBŐݒ肷( -10000() < lVolume < 0(ő) )
	if(m_pBasicAudio){
		if(lVolume>=-10000&&lVolume<=0){
			HRESULT hr = m_pBasicAudio->put_Volume(lVolume);
			if(SUCCEEDED(hr)){
				return true;
				}
			}
		}
	return false;
}

const bool CMediaViewer::GetVideoSize(WORD *pwWidth,WORD *pwHeight)
{
	// rfĨTCY擾
	if(m_pMpeg2SeqFilter){
		return m_pMpeg2SeqFilter->GetVideoSize(pwWidth,pwHeight);
		}
	return false;
}

const bool CMediaViewer::GetVideoAspectRatio(BYTE *pbyAspectRatioX,BYTE *pbyAspectRatioY)
{
	// rfĨAXyNg擾
	if(m_pMpeg2SeqFilter){
		return m_pMpeg2SeqFilter->GetAspectRatio(pbyAspectRatioX,pbyAspectRatioY);
		}
	return false;
}

const BYTE CMediaViewer::GetAudioChannelNum()
{
	// I[fBI̓̓`l擾
	if(m_pAacDecFilter){
		return m_pAacDecFilter->GetCurrentChannelNum();
		}
	return 0;
}

const bool CMediaViewer::SetStereoMode(const int iMode)
{
	// XeIo̓`l̐ݒ
	if(m_pPcmSelFilter){
		m_pPcmSelFilter->SetStereoMode(iMode);
		return true;
		}
	return false;
}

const bool CMediaViewer::GetVideoDecorderName(LPWSTR lpName,int iBufLen)
{
	// IĂrfIfR[_[̎擾
	if(m_pFilterGraph){
		if(strlen(m_szMpeg2DecorderName)+1<iBufLen){
			//lstrcpyW(lpName,m_szMpeg2DecorderName.GetBuffer());
			MultiByteToWideChar( CP_ACP, 0, m_szMpeg2DecorderName, -1, lpName, iBufLen );
			return true;
			}
		}
	return false;
}

const bool CMediaViewer::DisplayVideoDecorderProperty(HWND hWndParent)
{
	// rfIfR[_[̃vpeBJ
	bool bRet = false;
	FILTER_INFO FilterInfo;
	ISpecifyPropertyPages *pProp = NULL;
	IUnknown *pFilterUnk=NULL;;
	if(m_pMpeg2DecFilter){		
		HRESULT hr = m_pMpeg2DecFilter->QueryInterface(IID_ISpecifyPropertyPages, (void **)&pProp);
		if(SUCCEEDED(hr)){			
			CAUUID caGUID;
			pProp->GetPages(&caGUID);
			SAFE_RELEASE(pProp);
			hr = m_pMpeg2DecFilter->QueryFilterInfo(&FilterInfo);
			if(SUCCEEDED(hr)){				
				hr = m_pMpeg2DecFilter->QueryInterface(IID_IUnknown, (void **)&pFilterUnk);
				if(SUCCEEDED(hr)){
					OleCreatePropertyFrame(
						hWndParent,             // eEBhEB
						0, 0,                   // \ς݁B
						FilterInfo.achName,     // _CAO {bNX̃LvVB
						1,                      // IuWFNg (tB^̂)B
						&pFilterUnk,            // IuWFNg |C^̔zB
						caGUID.cElems,          // vpeB y[WB
						caGUID.pElems,          // vpeB y[W CLSID ̔zB
						0,                      // P[ʎqB
						0, NULL                 // \ς݁B
					);
					SAFE_RELEASE(pFilterUnk);
					bRet = true;
					}
				SAFE_RELEASE(FilterInfo.pGraph);
				}
			}
		}
	return bRet;
}

const bool CMediaViewer::DisplayVideoRanderProperty(HWND hWndParent)
{
	// IȂ̂ŁA
	return false;
}


HRESULT CMediaViewer::AddToRot(IUnknown *pUnkGraph, DWORD *pdwRegister) const
{
	// fobOp
	IMoniker * pMoniker;
	IRunningObjectTable *pROT;
	if(FAILED(::GetRunningObjectTable(0, &pROT)))return E_FAIL;
	
	WCHAR wsz[256];
#if 0
	wsprintfW(wsz, L"FilterGraph %08p pid %08x", (DWORD_PTR)pUnkGraph, ::GetCurrentProcessId());
#else
	wsz[255] = '\0';
	swprintf_s(wsz,255,L"FilterGraph %08p pid %08x", (DWORD_PTR)pUnkGraph, ::GetCurrentProcessId());
#endif

	HRESULT hr = ::CreateItemMoniker(L"!", wsz, &pMoniker);

	if(SUCCEEDED(hr)){
		hr = pROT->Register(0, pUnkGraph, pMoniker, pdwRegister);
		pMoniker->Release();
		}
	
	pROT->Release();
	
	return hr;
}

void CMediaViewer::RemoveFromRot(const DWORD dwRegister) const
{
	// fobOp
	IRunningObjectTable *pROT;

	if(SUCCEEDED(::GetRunningObjectTable(0, &pROT))){
		pROT->Revoke(dwRegister);
		pROT->Release();
		}
}

//////////////////////////////////////////////////////////////////////////////
//Add
BOOL CMediaViewer::GetSnapShot_BasicVideo(long *pBufferSize, long *pDIBImage){
	HRESULT hr;

	if(m_pBasicVideo == NULL)return FALSE;

	hr = m_pBasicVideo->GetCurrentImage(pBufferSize,pDIBImage);

	if(FAILED(hr))return FALSE;

	return TRUE;
}
