// TsPacketParser.cpp: CTsPacketParser NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include <windows.h>
#include "TsPacketParser.h"

/*#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif*/


#define TS_HEADSYNCBYTE		(0x47U)


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////


CTsPacketParser::CTsPacketParser(IEventHandler *pEventHandler)
	: CMediaDecoder(pEventHandler, 1UL, 1UL)
	, m_bOutputNullPacket(false)
	, m_dwInputPacketCount(0UL)
	, m_dwOutputPacketCount(0UL)
	, m_dwErrorPacketCount(0UL)
{
	// pPbgAJE^
	::FillMemory(m_abyContCounter, sizeof(m_abyContCounter), 0x10UL);
	
	//EPG擾̐ݒs
	m_cEpgCap.Initialize(TRUE);
	m_cEpgCap.SetPFOnly(TRUE);

	m_wEpgSID = 0;
	m_dwCurrentEventID = 0;
}

CTsPacketParser::~CTsPacketParser()
{
	m_cEpgCap.UnInitialize();

}

void CTsPacketParser::PutEpgSID(WORD wSID){
	m_wEpgSID = wSID;
	m_dwCurrentEventID = 0;
}

void CTsPacketParser::Reset(void)
{
	// pPbgJE^NA
	m_dwInputPacketCount =	0UL;
	m_dwOutputPacketCount = 0UL;
	m_dwErrorPacketCount =	0UL;

	// pPbgAJE^
	::FillMemory(m_abyContCounter, sizeof(m_abyContCounter), 0x10UL);

	// ԂZbg
	m_TsPacket.ClearSize();
	
	CMediaDecoder::Reset();
}

const bool CTsPacketParser::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	if(dwInputIndex >= GetInputNum())return false;
	if(!pMediaData)return false;

	// TSpPbg
	SyncPacket(pMediaData->GetData(), pMediaData->GetSize());

	return true;
}

void CTsPacketParser::SetOutputNullPacket(const bool bEnable)
{
	// NULLpPbg̏o͗Lݒ肷
	m_bOutputNullPacket = (bEnable)? true : false;
}

const DWORD CTsPacketParser::GetInputPacketCount(void) const
{
	// ̓pPbgԂ
	return m_dwInputPacketCount;
}

const DWORD CTsPacketParser::GetOutputPacketCount(void) const
{
	// o̓pPbgԂ
	return m_dwOutputPacketCount;
}

const DWORD CTsPacketParser::GetErrorPacketCount(void) const
{
	// G[pPbgԂ
	return m_dwErrorPacketCount;
}

void inline CTsPacketParser::SyncPacket(const BYTE *pData, const DWORD dwSize)
{
	// ̕@͊Sł͂ȂAꂽꍇɑOĂяõf[^܂ł̂ڂĂ͍ē͂łȂ
	DWORD dwCurSize = 0UL;
	DWORD dwCurPos = 0UL;

	while(dwCurPos < dwSize){
		dwCurSize = m_TsPacket.GetSize();

		if(!dwCurSize){
			// oCg҂
			for( ; dwCurPos < dwSize ; dwCurPos++){
				if(pData[dwCurPos] == TS_HEADSYNCBYTE){
					// oCg
					m_TsPacket.AddByte(TS_HEADSYNCBYTE);
					dwCurPos++;
					break;
					}				
				}
			
			continue;
			}
		else  if(dwCurSize == TS_PACKETSIZE){
			// pPbgTCYf[^

			if(pData[dwCurPos] == TS_HEADSYNCBYTE){
				// ̃f[^͓oCg
				ParsePacket();
				}
			else{
				// G[
				m_TsPacket.ClearSize();				
				
				// ʒuɖ߂
				if(dwCurPos >= (TS_PACKETSIZE - 1UL))dwCurPos -= (TS_PACKETSIZE - 1UL);
				else dwCurPos = 0UL;
				}

			continue;
			}
		else{
			// f[^҂
			if((dwSize - dwCurPos) >= (TS_PACKETSIZE - dwCurSize)){
				m_TsPacket.AddData(&pData[dwCurPos], TS_PACKETSIZE - dwCurSize);
				dwCurPos += (TS_PACKETSIZE - dwCurSize);
				}	
			else{
				m_TsPacket.AddData(&pData[dwCurPos], dwSize - dwCurPos);
				dwCurPos += (dwSize - dwCurPos);
				}			
			
			continue;
			}
		}
}

void inline CTsPacketParser::ParsePacket(void)
{
	// pPbg͂
	m_TsPacket.ParseHeader();

	if( m_TsPacket.GetPID() == 0x0000 || m_TsPacket.GetPID() == 0x0010 || 
		m_TsPacket.GetPID() == 0x0011 || m_TsPacket.GetPID() == 0x0012 || 
		m_TsPacket.GetPID() == 0x0014 ){

		//EPGp[TɃpPbgǉ	
		m_cEpgCap.AddTSPacket( m_TsPacket.GetData(), m_TsPacket.GetSize() );

		//݂EPG擾
		EPG_DATA_INFO Item;
		ZeroMemory(&Item, sizeof(EPG_DATA_INFO));

		if(m_cEpgCap.GetPFData(m_wEpgSID,&Item,FALSE)==NO_ERR){
			
			if(m_dwCurrentEventID != Item.dwEventID){

				m_dwCurrentEventID = Item.dwEventID;

				SendDecoderEvent(EID_EPG_PF_UPDATE);
			}
		}
	}


	// pPbg`FbN
	if(m_TsPacket.CheckPacket(&m_abyContCounter[m_TsPacket.GetPID()])){
		// ̓JEgCNg
		if(m_dwInputPacketCount < 0xFFFFFFFFUL)m_dwInputPacketCount++;

		// ̃fR[_Ƀf[^n
		if(m_bOutputNullPacket || (m_TsPacket.GetPID() != 0x1FFFU)){
			
			// o̓JEgCNg
			if(m_dwOutputPacketCount < 0xFFFFFFFFUL)m_dwOutputPacketCount++;
			
			OutputMedia(&m_TsPacket);
			}
		}
	else{
		// G[JEgCNg
		if(m_dwErrorPacketCount < 0xFFFFFFFFUL)m_dwErrorPacketCount++;
		}

	// TCYNÃXgAɔ
	m_TsPacket.ClearSize();
}

DWORD CTsPacketParser::GetProgramInfo(WORD wSID, BOOL bNext,ST_EPG_DATA *pData)
{
	EPG_DATA_INFO Item;
	ZeroMemory(&Item, sizeof(EPG_DATA_INFO));

	if(m_cEpgCap.GetPFData(wSID,&Item,bNext)==NO_ERR){
		//JnԂRs[
		CopyMemory(&pData->m_tmStart,&Item.stStartTime,sizeof(SYSTEMTIME));

		//IԂ߂
		FILETIME fFirstTime;
		SystemTimeToFileTime( &Item.stStartTime, &fFirstTime );
		__int64 i64TimeS = 0;
		i64TimeS = ((__int64)fFirstTime.dwHighDateTime)<<32 | fFirstTime.dwLowDateTime;
		__int64 i1Sec = (__int64)10000000;
		__int64 i64TimeE = i1Sec*Item.dwDurationSec+i64TimeS;

		fFirstTime.dwHighDateTime = (DWORD)(i64TimeE>>32);
		fFirstTime.dwLowDateTime = (DWORD)(i64TimeE&0x00000000FFFFFFFF);
		FileTimeToSystemTime(&fFirstTime,&pData->m_tmEnd);

		//f[^ϊ
		WideCharToMultiByte(CP_ACP, 0, Item.lpwszEventName, -1, &pData->m_szEventName[0], 119, NULL, NULL);
		WideCharToMultiByte(CP_ACP, 0, Item.lpwszEventText, -1, &pData->m_szEventText[0], 239, NULL, NULL);
		WideCharToMultiByte(CP_ACP, 0, Item.lpwszEventExtText, -1, &pData->m_szEventExtText[0], 511, NULL, NULL);
		pData->m_dwEventID = Item.dwEventID;
		pData->m_dwServiceID = Item.dwServiceID;
	}
	m_cEpgCap.ReleasePFData(&Item);

	return 0;
}
