// DtvEngine.h: CDtvEngine NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "..\BonTsEngine\mediaviewer.h"
#include "..\BonTsEngine\BonSrcDecoder.h"
#include "..\BonTsEngine\TsPacketParser.h"
#include "..\BonTsEngine\TsDescrambler.h"
#include "..\BonTsEngine\ProgManager.h"
#include "..\BonTsEngine\MediaTee.h"
#include "..\BonTsEngine\FileWriter.h"
#include "..\BonTsEngine\FileReader.h"

// ̕ӂ͑S̎bł


enum _enumDTV_ERRCODE{
	DTV_ERRCODE_NOERROR = 0,
	DTV_ERRCODE_INITILIZE,
	DTV_ERRCODE_BCAS,
	DTV_ERRCODE_DIRECTSHOW,
	DTV_ERRCODE_CANT_OPEN_FILE,
	DTV_ERRCODE_CANT_START_ASYNCH

};

enum _enumDTV_EVENT{
	DTV_EVENT_SERVICENAME_UPDATE	= 0x0000,
	DTV_EVENT_CHANGE_STREAM			= 0x0001,
	DTV_EVENT_EPGPF_UPDATE			= 0x0002,
};

//////////////////////////////////////////////////////////////////////
// fW^TVGWNX
//////////////////////////////////////////////////////////////////////

class CDtvEngineHandler;

class CDtvEngine : protected CMediaDecoder::IEventHandler
{
public:
	CDtvEngine(void);
	~CDtvEngine(void);

	//GW̐ݒ
	BOOL OpenEngine(CDtvEngineHandler *pDtvEngineHandler, HWND hHostHwnd,HWND hMessageDrainHwnd,HMODULE hBonDrvDll,BOOL bDescramble=true,int *pnErrCode = NULL);
	BOOL CloseEngine(void);
	BOOL ResetEngine(void);
	
	//ݒ	
	BOOL StartEngine(BOOL bPreview = TRUE);
	BOOL StopEngine(void);

	//rfIݒ
	BOOL SetViewSize(int x,int y);
	BOOL SwitchFullscreen();
	BOOL GetVideoSize(WORD *pwWidth,WORD *pwHeight);
	BOOL GetVideoAspectRatio(BYTE *pbyAspectRateX,BYTE *pbyAspectRateY);
	BOOL GetVideoDecorderName(LPWSTR lpName,int iBufLen);
	BOOL DisplayVideoDecorderProperty(HWND hWndParent);

	//ݒ
	BOOL SetVolume(long lVolume);
	BYTE GetAudioCahnnelNum();
	BOOL SetStereoMode(int iMode);

	//`lݒ
	BOOL SetChannel(BYTE byTuningSpace, WORD wChannel);
	BOOL SetService(WORD wService);
	WORD GetService(void);

	//ԑg̎擾
	DWORD GetProgramInfo(WORD wID, WORD wSID, BOOL bNext,LP_ST_EPG_DATA pData);
	
	//t@CĐ
	BOOL PlayFile(LPCTSTR lpszFileName,int *pnErrCode = NULL);
	BOOL StopFile(void);

	//t@Co
	BOOL StartCapture(char *pszFile);
	BOOL StopCapture(void);

	//GW̏Ԏ擾
	BOOL IsEnablePreview(void);
	BOOL IsFileMode(void);
	BOOL IsInit(void);
	BOOL IsStartEngine(void);
	BOOL IsCapture(void);
	DWORD GetRecTime(void);
	
	//G[R[h擾
	DWORD GetLastError(void);

	//Cxgnh
	DWORD SendDtvEngineEvent(DWORD dwEventID, PVOID pParam = NULL);
	virtual const DWORD OnDecoderEvent(CMediaDecoder *pDecoder, const DWORD dwEventID, PVOID pParam);

	// IMediaDecoder hfBAfR[_NX
	CBonSrcDecoder *m_pBonSrcDecoder;		// TS\[X`[i[(HALׂ)
	CTsPacketParser *m_pTsPacketParser;		// TSpPb^CU[
	CTsDescrambler *m_pTsDescrambler;		// TSfXNu[
	CProgManager *m_pProgManager;			// TSvO}l[W[
	CMediaViewer *m_pMediaViewer;			// fBAr[A[
	CMediaTee *m_pMediaTee;					// fBAeB[
	CFileWriter *m_pFileWriter;				// t@CC^[
	CFileReader *m_pFileReader;				// t@C[_[

private:

	CDtvEngineHandler *m_pDtvEngineHandler;
	WORD m_wCurTransportStream;
	WORD m_wCurService;
	WORD m_wCurVideoPID;
	WORD m_wCurAudioPID;

	BOOL m_bIsFileMode;
	BOOL m_bIsInit;
	BOOL m_bIsEnablePreview;
	BOOL m_bStartEngine;
	BOOL m_bIsCapture;

	DWORD m_dwRecTime;
};


//////////////////////////////////////////////////////////////////////
// fW^TVCxgnhC^tF[X
//////////////////////////////////////////////////////////////////////

// ͏z֐Ƃׂ
class CDtvEngineHandler
{
friend CDtvEngine;

protected:
	virtual const DWORD OnDtvEngineEvent(CDtvEngine *pEngine, const DWORD dwEventID, PVOID pParam);
};
