#include <windows.h>
#include <stdio.h>

#include "CMainWindow.h"
#include "..\DirectShow\ds_util.h"
#include "..\Dialog\CPropCfgDlg.h"
#include "..\util\StrUtil.h"
#include "..\resource.h"

//////////////////////////////////////////////////////////////////////////////
//DirectShow֐
BOOL CMainWindow::DSObj_Init(void){

	BOOL lRet;

	if(m_pDsCap == NULL){
		m_pDsCap = new CDSCap;
	}
	if(m_pDsCap->IsInit() == TRUE)return TRUE;

	lRet = m_pDsCap->InitCapFilters("SKNET HDTV BDA Digital Capture_0","SKNET HDTV BDA Digital Tuner_0");

	return lRet;
}

BOOL CMainWindow::DSObj_UnInit(void){
	if(m_pDsCap == NULL)return TRUE;
	
	m_pDsCap->FreeCapFilters();

	delete m_pDsCap;
	m_pDsCap = NULL;

	return TRUE;
}

BOOL CMainWindow::DSObj_BuildPreview(void){
	BOOL lRet;

	if(m_pDsCap == NULL)return FALSE;
	
	lRet = m_pDsCap->BuildGraph(DumpCallBack,this);
//	m_pDsCap->SetAspectMode(1);

	m_pDsCap->PutChannel(0,50);
	
	return TRUE;
}

BOOL CMainWindow::DSObj_BuildCapture(void){
	if(m_pDsCap == NULL)return FALSE;
	return TRUE;
}

BOOL CMainWindow::DSObj_Start(void){
	if(m_pDsCap == NULL)return FALSE;

	m_pDsCap->Start();

	return TRUE;
}

BOOL CMainWindow::DSObj_Stop(void){
	if(m_pDsCap == NULL)return FALSE;

	m_pDsCap->Stop();
	m_pDsCap->TearDownGraph();

	return TRUE;
}

BOOL CMainWindow::DSObj_SetHandle(void){

//	IVideoWindow *pVW;
	IMediaEventEx *pEv;

	if(m_pDsCap == NULL)return FALSE;

/*	pVW = m_pDsCap->GetVideoWindow();
	if(pVW != NULL){
		pVW->put_Owner((OAHWND)m_hWnd);
		pVW->put_MessageDrain((OAHWND)m_hWnd);
		pVW->put_WindowStyle(WS_CHILD);
	}*/

	pEv = m_pDsCap->GetMediaEvent();
	if(pEv != NULL){
		pEv->SetNotifyWindow((OAHWND)m_hWnd,WM_DS_NOTIFY,NULL);
	}

	return TRUE;
}

BOOL CMainWindow::DSObj_SetWindowPos(RECT *pRc){
/*	IVideoWindow *pVW;
	if(m_pDsCap == NULL)return FALSE;

	pVW = m_pDsCap->GetVideoWindow();
	if(pVW == NULL)return FALSE;

	pVW->SetWindowPosition(pRc->left,pRc->top,pRc->right - pRc->left,pRc->bottom - pRc->top);
*/
	return TRUE;
}


BOOL CMainWindow::DSObj_ShowWindow(BOOL bIsShow){

/*	IVideoWindow *pVW;
	long lVisible;

	if(m_pDsCap == NULL)return FALSE;
	pVW = m_pDsCap->GetVideoWindow();
	if(pVW == NULL)return FALSE;

	if(bIsShow == TRUE)
		lVisible = OATRUE;
	else
		lVisible = OAFALSE;
	
	pVW->put_Visible(lVisible);
*/
	return TRUE;
}

BOOL CMainWindow::DSObj_PutChannel(long lCh){
	IAMTVTuner *pTV = NULL;

	if(m_pDsCap == NULL)return FALSE;
#if 0
	pTV = m_pDsCap->GetTVTuner();
	if(pTV == NULL)return FALSE;

	pTV->put_Channel(ConverCh_CATVToDS(lCh),AMTUNER_SUBCHAN_DEFAULT,AMTUNER_SUBCHAN_DEFAULT);
#endif
	return TRUE;
}

BOOL CMainWindow::DSObj_PutVideoSize(int nWidth,int nHeight){
#if 0
	if(m_pDsCap == NULL)return FALSE;
	
	AM_MEDIA_TYPE *pmt = NULL;
	HRESULT hr;
	VIDEOINFOHEADER *pVInfo;

	hr = m_pDsCap->VSC_GetFormat(&pmt);
	if(FAILED(hr)) return FALSE;

	if(pmt->formattype != FORMAT_VideoInfo)return FALSE;

	pVInfo = (VIDEOINFOHEADER *)pmt->pbFormat;

	pmt->subtype = MEDIASUBTYPE_UYVY;
	pVInfo->bmiHeader.biWidth = nWidth;
	pVInfo->bmiHeader.biHeight = nHeight;

	hr = m_pDsCap->VSC_SetFormat(pmt);

	DeleteMediaType(pmt);

	if(FAILED(hr)) return FALSE;
#endif

	return TRUE;
}
